module Rewire
  class Pipe
    def initialize(&logic)
      @logic = logic
    end

    def |(pipe)
      Emitter.new(self) | pipe
    end

    def <<(pack)
      output = []
      (self | output) << pack
      output
    end

    def process(receiver, pack)
      @logic[receiver, pack]
    end
  end
end
